# 
# * 6.6 Генераторы множеств и словарей
# 

'''Подвиг 2. Вводится строка со списком оценок, например:
2 неудовлетворительно удовлетворительно хорошо отлично
Первая цифра - это числовое значение первой оценки. Остальные оценки
имеют возрастающие на 1 числа. С помощью генератора словарей необходимо
сформировать словарь d, где ключами будут выступать числа, а значениями
- слова. Например:
d = {2: 'неудовлетворительно', 3: 'удовлетворительно', 4: 'хорошо', 5: 'отлично'}
Вывести на экран значение сформированного словаря с ключом 4.
Sample Input:
1 ужасно неудовлетворительно удовлетворительно прилично отлично
Sample Output:
прилично
'''

# r = input().split()
# r[0] = int(r[0])
# # d = {key: value for key, value in enumerate(r[1:], r[0])}
# d = dict(enumerate(r[1:], r[0]))
# print(d[4])

'''
Подвиг 3. На автомойку в течение квартала заезжали машины. Их гос. номера
фиксировались в журнале, следующим образом (пример):
Е220СК
А120МВ
В101АА
Е220СК
А120МВ
На основе такого списка через генератор множеств сформировать список
уникальных машин. На экран вывести число уникальных машин.
P. S. Для считывания списка целиком в программе уже записаны начальные строчки.
Sample Input:
А323ГД
Д456ВВ
Б001ББ
Д456ВВ
С111СС
Sample Output:
4
'''

# import sys
# # считывание списка из входного потока
# lst_in = list(map(str.strip, sys.stdin.readlines()))
# # здесь продолжайте программу (используйте список lst_in)
# # Без генераторов print(len(set(lst_in)))
# print(len({x for x in lst_in}))

'''
Подвиг 4. Вводится текст в одну строчку со словами через пробел.
С помощью генератора множеств сформировать множество из уникальных слов
без учета регистра и длина которых не менее трех символов.
Вывести на экран размер этого множества.
Sample Input:
Хижина изба машина и снова хижина машина
Sample Output:
4
'''
# print(len({x for x in input().lower().split() if len(x) > 2}))

'''
Подвиг 5. Вводится текст в одну строчку со словами через пробел.
Используя генераторы множеств и словарей, сформировать словарь в формате:
{слово_1: количество_1, слово_2: количество_2, ..., слово_N: количество_N}
То есть, ключами выступают уникальные слова (без учета регистра), а
значениями - число их встречаемости в тексте. На экран вывести значение
словаря для слова (союза) 'и'. Если такого ключа нет, то вывести 0.
Sample Input:
И что сказать и что сказать и нечего и точка
Sample Output:
4
'''
# s = input().lower().split()
# d = {key: s.count(key) for key in s}
# if d.get('и') is None:
#     print(0)
# else:
#     print(d.get('и'))

'''
Подвиг 6. Вводится список книг книжного магазина в формате:
<автор 1>:<название 1>
...
<автор N>:<название N>
Авторы с названиями могут повторяться. Необходимо, используя генераторы,
сформировать словарь с именем d вида:
{'автор 1': {'название 1', 'название 2', ..., 'название M'}, ..., 'автор K': {'название 1', 'название 2', ..., 'название S'}}
То есть, ключами выступают уникальные авторы, а значениями - множества с
уникальными названиями книг соответствующего автора.
На экран ничего выводить не нужно, только сформировать словарь
обязательно с именем d - он, далее будет проверяться в тестах!
P. S. Для считывания списка целиком в программе уже записаны начальные строчки.
Sample Input:
Пушкин: Сказака о рыбаке и рыбке
Есенин: Письмо к женщине
Тургенев: Муму
Пушкин: Евгений Онегин
Есенин: Русь
Sample Output:
True
'''

import sys
# считывание списка из входного потока
lst_in = list(map(str.strip, sys.stdin.readlines()))
# здесь продолжайте программу (используйте список lst_in)
d = {n.split(': ')[0]: {b.split(': ')[1] for b in lst_in 
                                if n.split(': ')[0] == b.split(': ')[0]}
        for n in lst_in}
# print(d)